package Server::Info;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;

use Net::SSH qw/ssh_cmd/;
use Text::CSV;

use UNIVERSAL::require;
use Module::Pluggable 
    search_path => 'Server::Info',
    except      => qr/^Server::Info::Format/,

__PACKAGE__->mk_accessors(qw/host/);

sub get {
    my ($class, $host) = @_;
    my $self = $class->new({
        host => $host,
    });

    for ($self->plugins) {
        m/.+::(.+)$/;
        $_->require or die $@;
        my $attr = lc $1;
        $self->mk_accessors($attr);
        $self->$attr = $_->get($host);
    }
    $self;
}

sub as {
    my ($self, $format) = @_;
    my $module = join '::', "Server::Info::Format", ucfirst $format;
    $module->require or die $@;
    $module->format($self);
}

1;
