package Server::Info::Format::Table;
use strict;
use warnings;
use Text::ASCIITable;

sub format {
    my ($class, $info) = @_;
    my $t = Text::ASCIITable->new;
    $t->setCols('Title', 'Value');
    $t->alignCol('Value', 'left');
    $t->addRow('Host', $info->host);
    $t->addRow('CPU model', $info->cpu->model);
    $t->addRow('Number of CPU', $info->cpu->number);
    $t->addRow('Amount of Memory', $info->memory->size);
    return $t->draw;
}

1;

