package Server::Info::Memory;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;
use Net::SSH qw/ssh_cmd/;

__PACKAGE__->mk_accessors(qw/size/);

sub get {
    my ($class, $host) = @_;
    my $self = $class->new;
    $self->_init($host);
    return $self;
}

sub _init {
    my ($self, $host) = @_;
    my $meminfo = ssh_cmd $host, "free | grep 'Mem:'";
    ($self->size) = $meminfo =~ m/^Mem:\s+(\d+)/;
}

1;
