package Server::Info;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;

use Net::SSH qw/ssh_cmd/;
use Text::CSV;

use Module::Pluggable 
    search_path => ['Server::Info'],
    require     => 1;

__PACKAGE__->mk_accessors(qw/host/);

sub get {
    my ($class, $host) = @_;
    my $self = $class->new({
        host => $host,
    });

    for ($self->plugins) {
        m/.+::(.+)$/;
        my $attr = lc $1;
        $self->mk_accessors($attr);
        $self->$attr = $_->get($host);
    }
    $self;
}

sub as_csv {
    my $self = shift;
    my $csv = Text::CSV->new;
    $csv->combine(
        $self->host,
        $self->cpu->model,
        $self->cpu->number,
        $self->memory->size,
        $self->kernel->version,
    );
    return $csv->string;
}

1;
