package Server::Info::CPU;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;
use Net::SSH qw/ssh_cmd/;

__PACKAGE__->mk_accessors(qw/model number/);

sub get {
    my ($class, $host) = @_;
    my $self = $class->new;
    $self->_init($host);
    return $self;
}

sub _init {
    my ($self, $host) = @_;
    my $cpuinfo = ssh_cmd $host, 'cat /proc/cpuinfo';
    $self->number = grep { m/^model name/ } split/\n/, $cpuinfo;
    ($self->model) = $cpuinfo =~ m/model name\s+:(.*)/;
}

1;
