package Server::Info::Kernel;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;
use Net::SSH qw/ssh_cmd/;

__PACKAGE__->mk_accessors(qw/version/);

sub get {
    my ($class, $host) = @_;
    my $self = $class->new;
    $self->version = ssh_cmd $host, "uname -r";
    chomp $self->version;
    $self;
}

1;

