#!/usr/local/bin/perl
use strict;
use warnings;
use Net::SSH qw/ssh_cmd/;

for my $addr (@ARGV) {
    my $cpuinfo = ssh_cmd $addr, 'cat /proc/cpuinfo';
    my ($cpu_model, $num_of_cpu) = parse_cpuinfo($cpuinfo);
    print <<EOF;
Host: $addr
CPU model: $cpu_model
Number of CPU: $num_of_cpu
EOF
}

sub parse_cpuinfo {
    my $cpuinfo = shift;
    my ($cpu_model, $num_of_cpu);

    my @lines = split /\n/, $cpuinfo;
    for my $line (@lines) {
        if ($line =~ m/^model name\s+:(.*)/) {
            $num_of_cpu++;
            $cpu_model = $1;
        }
    }
    return ($cpu_model, $num_of_cpu);
}
